unit optdodef; { Delphi object wrapper generated by apiwrapper }

{$H- short only }
{$P- no open parameters ==> no maxlen byte}
{$V+ force var strings}

interface

uses
   {$I p3compat},
   gmsgen;


const optDataNone    = 0;  { optDataType }
      optDataInteger = 1;
      optDataDouble  = 2;
      optDataString  = 3;
      optDataStrList = 4;

const optTypeInteger   = 0;  { optOptionType }
      optTypeDouble    = 1;
      optTypeString    = 2;
      optTypeBoolean   = 3;
      optTypeEnumStr   = 4;
      optTypeEnumInt   = 5;
      optTypeMultiList = 6;
      optTypeStrList   = 7;
      optTypeMacro     = 8;
      optTypeImmediate = 9;

const optsubRequired = 0;  { optOptionSubType }
      optsubNoValue  = 1;
      optsubOptional = 2;
      optsub2Values  = 3;

const optMsgInputEcho    = 0;  { optMsgType }
      optMsgHelp         = 1;
      optMsgDefineError  = 2;
      optMsgValueError   = 3;
      optMsgValueWarning = 4;
      optMsgDeprecated   = 5;
      optMsgFileEnter    = 6;
      optMsgFileLeave    = 7;
      optMsgTooManyMsgs  = 8;
      optMsgUserError    = 9;

//tries to load DLL from OS default location
//name for the DLL is automatic
function  optGetReady(var Msg: ShortString): boolean;
//tries to load DLL from main program directory; if that fails
//loads DLL from OS default location
//name for the DLL is automatic
function  optGetReadyX(var Msg: ShortString): boolean;
//loads DLL from specified directory
//name for the DLL is automatic
function  optGetReadyD(const Dir: ShortString; var Msg: ShortString): boolean;
//loads DLL from the full path specified
//no changes are made to the name (platform and file extension)
function  optGetReadyL(const LibName: ShortString; var Msg: ShortString): boolean;

procedure optSetLoadPath(const s: shortString);
procedure optGetLoadPath(var s: shortString);

procedure optLibraryUnload;
function  optLibraryLoaded: boolean;


type
   TErrorCallback  = function(ErrCount:Integer; const Msg:ShortString):Integer; {$I decorate};
   PTErrorCallBack = ^TErrorCallBack;

   TGmsOptions = Class
   private
      popt  : pointer;
      extern: boolean;

      function  DoptCount           : Integer;
      function  DoptMessageCount    : Integer;
      function  DoptGroupCount      : Integer;
      function  DoptRecentEnabled   : Integer;
      procedure DoptRecentEnabledSet(x: Integer);
   public
      constructor Create          (var Msg: ShortString);
      constructor CreateX         (var Msg: ShortString);
      constructor CreateD         (const Dir: ShortString; var Msg: ShortString);
      constructor CreateL         (const LibName: ShortString; var Msg: ShortString);
      constructor CreateWithHandle(p: pointer; var Msg: ShortString);
      destructor  Destroy         ; override; { always use free and never destroy }

      function  optGetHandle            : pointer;
      function  optGetScreenIndicator   : boolean;
      procedure optSetScreenIndicator   (const ScrInd: boolean);
      function  optGetExceptionIndicator: boolean;
      procedure optSetExceptionIndicator(const ExcInd: boolean);
      function  optGetExitIndicator     : boolean;
      procedure optSetExitIndicator     (const ExtInd: boolean);
      function  optGetErrorCallback     : PTErrorCallback;
      procedure optSetErrorCallback     (ecb: PTErrorCallback);
      function  optGetErrorCount        : Integer;
      procedure optSetErrorCount        (const ecnt: Integer);

      function  optReadDefinition    (const fn: ShortString): Integer;
      function  optReadParameterFile (const fn: ShortString): Integer;
      procedure optReadFromStr       (const s: ShortString);
      function  optWriteParameterFile(const fn: ShortString): Integer;
      procedure optClearMessages     ;
      procedure optAddMessage        (const info: ShortString);
      procedure optGetMessage        (N: Integer; var info: ShortString; var iType: Integer);
      procedure optResetAll          ;
      procedure optResetAllRecent    ;
      procedure optResetRecentChanges;
      procedure optShowHelp          (const HlpID: ShortString);
      function  optResetNr           (ANr: Integer): Integer;
      function  optFindStr           (const AName: ShortString; var ANr: Integer; var ARefNr: Integer): Integer;
      function  optGetInfoNr         (ANr: Integer; var ADefined: Integer; var ADefinedR: Integer; var ARefNr: Integer; var ADataType: Integer; var AOptType: Integer; var ASubType: Integer): Integer;
      function  optGetValuesNr       (ANr: Integer; var ASName: ShortString; var AIVal: Integer; var ADVal: Double; var ASVal: ShortString): Integer;
      function  optSetValuesNr       (ANr: Integer; AIVal: Integer; ADVal: Double; const ASVal: ShortString): Integer;
      function  optSetValues2Nr      (ANr: Integer; AIVal: Integer; ADVal: Double; const ASVal: ShortString): Integer;
      procedure optVersion           (var sversion: ShortString);
      procedure optDefinitionFile    (var sfilename: ShortString);
      function  optGetFromAnyStrList (idash: Integer; var skey: ShortString; var sval: ShortString): Integer;
      function  optGetFromListStr    (const skey: ShortString; var sval: ShortString): Integer;
      function  optListCountStr      (const skey: ShortString): Integer;
      function  optReadFromListStr   (const skey: ShortString; iPos: Integer; var sval: ShortString): Integer;
      function  optSynonymCount      : Integer;
      function  optGetSynonym        (N: Integer; var SSyn: ShortString; var SName: ShortString): Integer;
      procedure optEchoSet           (V: Integer);
      function  optEOLOnlySet        (ival: Integer): Integer;
      procedure optNoBoundsSet       (ival: Integer);
      procedure optErrorCount        (var iErrors: Integer; var iWarnings: Integer);
      function  optGetBoundsInt      (ANr: Integer; var ilval: Integer; var ihval: Integer; var idval: Integer): Integer;
      function  optGetBoundsDbl      (ANr: Integer; var dlval: Double; var dhval: Double; var ddval: Double): Integer;
      function  optGetDefaultStr     (ANr: Integer; var sval: ShortString): Integer;
      function  optGetIntNr          (ANr: Integer; var AIVal: Integer): Integer;
      function  optGetInt2Nr         (ANr: Integer; var AIVal: Integer): Integer;
      function  optSetIntNr          (ANr: Integer; AIVal: Integer): Integer;
      function  optSetInt2Nr         (ANr: Integer; AIVal: Integer): Integer;
      function  optGetStrNr          (ANr: Integer; var ASVal: ShortString): Integer;
      function  optGetOptHelpNr      (ANr: Integer; var AName: ShortString; var AHc: Integer; var AGroup: Integer): Integer;
      function  optGetEnumHelp       (ANr: Integer; AOrd: Integer; var AHc: Integer; var AHelpStr: ShortString): Integer;
      function  optGetEnumStrNr      (ANr: Integer; var ASVal: ShortString; var AOrd: Integer): Integer;
      function  optGetEnumCount      (ANr: Integer; var ACount: Integer): Integer;
      function  optGetEnumValue      (ANr: Integer; AOrd: Integer; var AValInt: Integer; var AValStr: ShortString): Integer;
      function  optGetStr2Nr         (ANr: Integer; var ASVal: ShortString): Integer;
      function  optSetStrNr          (ANr: Integer; const ASVal: ShortString): Integer;
      function  optSetStr2Nr         (ANr: Integer; const ASVal: ShortString): Integer;
      function  optGetDblNr          (ANr: Integer; var ADVal: Double): Integer;
      function  optGetDbl2Nr         (ANr: Integer; var ADVal: Double): Integer;
      function  optSetDblNr          (ANr: Integer; ADVal: Double): Integer;
      function  optSetDbl2Nr         (ANr: Integer; ADVal: Double): Integer;
      function  optGetValStr         (const AName: ShortString; var ASVal: ShortString): Integer;
      function  optGetVal2Str        (const AName: ShortString; var ASVal: ShortString): Integer;
      function  optGetNameNr         (ANr: Integer; var ASName: ShortString): Integer;
      function  optGetDefinedNr      (ANr: Integer; var AIVal: Integer): Integer;
      function  optGetHelpNr         (ANr: Integer; var ASOpt: ShortString; var ASHelp: ShortString): Integer;
      function  optGetGroupNr        (ANr: Integer; var AName: ShortString; var AGroup: Integer; var AHc: Integer; var AHelp: ShortString): Integer;
      function  optGetGroupGrpNr     (AGroup: Integer): Integer;
      function  optGetOptGroupNr     (ANr: Integer): Integer;
      function  optGetDotOptNr       (ANr: Integer; var AName: ShortString; var AObjNr: Integer; var ADim: Integer; var AValue: Double): Integer;
      function  optGetDotOptUel      (ANr: Integer; ADim: Integer; var AUEL: ShortString): Integer;
      function  optGetIndicatorNr    (ANr: Integer; var EquName: ShortString; var VarName: ShortString; var EquDim: Integer; var VarDim: Integer; var AValue: Integer): Integer;
      function  optGetEquIndicatorNr (ANr: Integer; ADim: Integer; var AIndex: ShortString): Integer;
      function  optGetVarIndicatorNr (ANr: Integer; ADim: Integer; var AIndex: ShortString): Integer;
      function  optIndicatorCount    (var ANrErrors: Integer): Integer;
      function  optDotOptCount       (var ANrErrors: Integer): Integer;
      function  optSetRefNr          (ANr: Integer; AValue: Integer): Integer;
      function  optSetRefNrStr       (const AOpt: ShortString; AValue: Integer): Integer;
      function  optGetConstName      (cgroup: Integer; cindex: Integer; var cname: ShortString): Integer;
      function  optGetTypeName       (TNr: Integer; var sTName: ShortString): Integer;
      function  optLookUp            (const AOpt: ShortString): Integer;
      procedure optReadFromPChar     (p: PChar);

 { recovered properties }
      property optCount         : Integer read DoptCount;
      property optMessageCount  : Integer read DoptMessageCount;
      property optGroupCount    : Integer read DoptGroupCount;
      property optRecentEnabled : Integer read DoptRecentEnabled write DoptRecentEnabledSet;
   end;

implementation
uses
   optdcdef;

function optGetReady(var Msg: ShortString): boolean;
begin
Result := optdcdef.optGetReady(Msg);
end;

function  optGetReadyX(var Msg: ShortString): boolean;
begin
Result := optdcdef.optGetReadyX(Msg);
end;

function  optGetReadyD(const Dir: ShortString; var Msg: ShortString): boolean;
begin
Result := optdcdef.optGetReadyD(Dir,Msg);
end;

function  optGetReadyL(const LibName: ShortString; var Msg: ShortString): boolean;
begin
Result := optdcdef.optGetReadyL(LibName,Msg);
end;

procedure optSetLoadPath(const s: shortString);
begin
optdcdef.optSetLoadPath(s);
end;

procedure optGetLoadPath(var s: shortString);
begin
optdcdef.optGetLoadPath(s);
end;

procedure optLibraryUnload;
begin
optdcdef.optLibraryUnload;
end;

function  optLibraryLoaded: boolean;
begin
Result := optdcdef.optLibraryLoaded;
end;

constructor TGmsOptions.Create(var Msg: ShortString);
var
  ok: boolean;
begin
  inherited Create;
  extern := false;
  ok := optdcdef.optCreate(popt, Msg);
  if not ok then begin
    popt := nil;
    if Msg = '' then
       Msg := 'Unknown error calling TGmsOptions.Create';
  end
  else Msg := '';
end; (* TGmsOptions.Create *)

constructor TGmsOptions.CreateX(var Msg: ShortString);
var
  ok: boolean;
begin
  inherited Create;
  extern := false;
  ok := optdcdef.optCreateX(popt, Msg);
  if not ok then begin
    popt := nil;
    if Msg = '' then
       Msg := 'Unknown error calling TGmsOptions.CreateX';
  end
  else Msg := '';
end; (* TGmsOptions.CreateX *)

constructor TGmsOptions.CreateD(const Dir: ShortString; var Msg: ShortString);
var
  ok: boolean;
begin
  inherited Create;
  extern := false;
  ok := optdcdef.optCreateD(popt, Dir, Msg);
  if not ok then begin
    popt := nil;
    if Msg = '' then
       Msg := 'Unknown error calling TGmsOptions.CreateD';
  end
  else Msg := '';
end; (* TGmsOptions.CreateD *)

constructor TGmsOptions.CreateL(const LibName: ShortString; var Msg: ShortString);
var
  ok: boolean;
begin
  inherited Create;
  extern := false;
  ok := optdcdef.optCreateL(popt, LibName, Msg);
  if not ok then begin
    popt := nil;
    if Msg = '' then
       Msg := 'Unknown error calling TGmsOptions.CreateL';
  end
  else Msg := '';
end; (* TGmsOptions.CreateL *)

constructor TGmsOptions.CreateWithHandle(p: pointer; var Msg: ShortString);
var
  ok: boolean;
begin
  inherited Create;
  extern := true;
  popt := p;
  ok := optdcdef.optGetReady(Msg);
  if not ok then begin
    popt := nil;
    if Msg = '' then
       Msg := 'Unknown error calling TGmsOptions.CreateWithHandle';
  end
  else Msg := '';
end; (* TGmsOptions.CreateWithHandle *)

destructor TGmsOptions.Destroy;
begin
if not extern
then
   optdcdef.optFree(popt);
inherited destroy;
end;

function TGmsOptions.optGetHandle: pointer;
begin
Result := popt;
end;

function  TGmsOptions.optGetScreenIndicator: Boolean;
begin
result := optdcdef.optGetScreenIndicator;
end;

procedure TGmsOptions.optSetScreenIndicator(const ScrInd: Boolean);
begin
optdcdef.optSetScreenIndicator(ScrInd);
end;

function  TGmsOptions.optGetExceptionIndicator: Boolean;
begin
result := optdcdef.optGetExceptionIndicator;
end;

procedure TGmsOptions.optSetExceptionIndicator(const ExcInd: Boolean);
begin
optdcdef.optSetExceptionIndicator(ExcInd);
end;

function  TGmsOptions.optGetExitIndicator: Boolean;
begin
result := optdcdef.optGetExitIndicator;
end;

procedure TGmsOptions.optSetExitIndicator(const ExtInd: Boolean);
begin
optdcdef.optSetExitIndicator(ExtInd);
end;

function  TGmsOptions.optGetErrorCount: Integer;
begin
result := optdcdef.optGetErrorCount;
end;

procedure TGmsOptions.optSetErrorCount(const ecnt: Integer);
begin
optdcdef.optSetErrorCount(ecnt);
end;

function  TGmsOptions.optGetErrorCallback: PTErrorCallBack;
begin
result := PTErrorCallBack(optdcdef.optGetErrorCallback);
end;

procedure TGmsOptions.optSetErrorCallback(ecb: PTErrorCallBack);
begin
optdcdef.optSetErrorCallback(TErrorCallBack(ecb));
end;


function  TGmsOptions.DoptCount: Integer;
begin
result := optdcdef.optCount(popt);
end;

function  TGmsOptions.DoptMessageCount: Integer;
begin
result := optdcdef.optMessageCount(popt);
end;

function  TGmsOptions.DoptGroupCount: Integer;
begin
result := optdcdef.optGroupCount(popt);
end;

function  TGmsOptions.DoptRecentEnabled: Integer;
begin
result := optdcdef.optRecentEnabled(popt);
end;

procedure TGmsOptions.DoptRecentEnabledSet(x: Integer);
begin
optdcdef.optRecentEnabledSet(popt,X);
end;

function  TGmsOptions.optReadDefinition(const fn: ShortString): Integer;
begin
result := optdcdef.optReadDefinition(popt, fn);
end;

function  TGmsOptions.optReadParameterFile(const fn: ShortString): Integer;
begin
result := optdcdef.optReadParameterFile(popt, fn);
end;

procedure TGmsOptions.optReadFromStr(const s: ShortString);
begin
optdcdef.optReadFromStr(popt, s);
end;

function  TGmsOptions.optWriteParameterFile(const fn: ShortString): Integer;
begin
result := optdcdef.optWriteParameterFile(popt, fn);
end;

procedure TGmsOptions.optClearMessages;
begin
optdcdef.optClearMessages(popt);
end;

procedure TGmsOptions.optAddMessage(const info: ShortString);
begin
optdcdef.optAddMessage(popt, info);
end;

procedure TGmsOptions.optGetMessage(N: Integer; var info: ShortString; var iType: Integer);
begin
optdcdef.optGetMessage(popt, N, info, iType);
end;

procedure TGmsOptions.optResetAll;
begin
optdcdef.optResetAll(popt);
end;

procedure TGmsOptions.optResetAllRecent;
begin
optdcdef.optResetAllRecent(popt);
end;

procedure TGmsOptions.optResetRecentChanges;
begin
optdcdef.optResetRecentChanges(popt);
end;

procedure TGmsOptions.optShowHelp(const HlpID: ShortString);
begin
optdcdef.optShowHelp(popt, HlpID);
end;

function  TGmsOptions.optResetNr(ANr: Integer): Integer;
begin
result := optdcdef.optResetNr(popt, ANr);
end;

function  TGmsOptions.optFindStr(const AName: ShortString; var ANr: Integer; var ARefNr: Integer): Integer;
begin
result := optdcdef.optFindStr(popt, AName, ANr, ARefNr);
end;

function  TGmsOptions.optGetInfoNr(ANr: Integer; var ADefined: Integer; var ADefinedR: Integer; var ARefNr: Integer; var ADataType: Integer; var AOptType: Integer; var ASubType: Integer): Integer;
begin
result := optdcdef.optGetInfoNr(popt, ANr, ADefined, ADefinedR, ARefNr, ADataType, AOptType, ASubType);
end;

function  TGmsOptions.optGetValuesNr(ANr: Integer; var ASName: ShortString; var AIVal: Integer; var ADVal: Double; var ASVal: ShortString): Integer;
begin
result := optdcdef.optGetValuesNr(popt, ANr, ASName, AIVal, ADVal, ASVal);
end;

function  TGmsOptions.optSetValuesNr(ANr: Integer; AIVal: Integer; ADVal: Double; const ASVal: ShortString): Integer;
begin
result := optdcdef.optSetValuesNr(popt, ANr, AIVal, ADVal, ASVal);
end;

function  TGmsOptions.optSetValues2Nr(ANr: Integer; AIVal: Integer; ADVal: Double; const ASVal: ShortString): Integer;
begin
result := optdcdef.optSetValues2Nr(popt, ANr, AIVal, ADVal, ASVal);
end;

procedure TGmsOptions.optVersion(var sversion: ShortString);
begin
optdcdef.optVersion(popt, sversion);
end;

procedure TGmsOptions.optDefinitionFile(var sfilename: ShortString);
begin
optdcdef.optDefinitionFile(popt, sfilename);
end;

function  TGmsOptions.optGetFromAnyStrList(idash: Integer; var skey: ShortString; var sval: ShortString): Integer;
begin
result := optdcdef.optGetFromAnyStrList(popt, idash, skey, sval);
end;

function  TGmsOptions.optGetFromListStr(const skey: ShortString; var sval: ShortString): Integer;
begin
result := optdcdef.optGetFromListStr(popt, skey, sval);
end;

function  TGmsOptions.optListCountStr(const skey: ShortString): Integer;
begin
result := optdcdef.optListCountStr(popt, skey);
end;

function  TGmsOptions.optReadFromListStr(const skey: ShortString; iPos: Integer; var sval: ShortString): Integer;
begin
result := optdcdef.optReadFromListStr(popt, skey, iPos, sval);
end;

function  TGmsOptions.optSynonymCount: Integer;
begin
result := optdcdef.optSynonymCount(popt);
end;

function  TGmsOptions.optGetSynonym(N: Integer; var SSyn: ShortString; var SName: ShortString): Integer;
begin
result := optdcdef.optGetSynonym(popt, N, SSyn, SName);
end;

procedure TGmsOptions.optEchoSet(V: Integer);
begin
optdcdef.optEchoSet(popt, V);
end;

function  TGmsOptions.optEOLOnlySet(ival: Integer): Integer;
begin
result := optdcdef.optEOLOnlySet(popt, ival);
end;

procedure TGmsOptions.optNoBoundsSet(ival: Integer);
begin
optdcdef.optNoBoundsSet(popt, ival);
end;

procedure TGmsOptions.optErrorCount(var iErrors: Integer; var iWarnings: Integer);
begin
optdcdef.optErrorCount(popt, iErrors, iWarnings);
end;

function  TGmsOptions.optGetBoundsInt(ANr: Integer; var ilval: Integer; var ihval: Integer; var idval: Integer): Integer;
begin
result := optdcdef.optGetBoundsInt(popt, ANr, ilval, ihval, idval);
end;

function  TGmsOptions.optGetBoundsDbl(ANr: Integer; var dlval: Double; var dhval: Double; var ddval: Double): Integer;
begin
result := optdcdef.optGetBoundsDbl(popt, ANr, dlval, dhval, ddval);
end;

function  TGmsOptions.optGetDefaultStr(ANr: Integer; var sval: ShortString): Integer;
begin
result := optdcdef.optGetDefaultStr(popt, ANr, sval);
end;

function  TGmsOptions.optGetIntNr(ANr: Integer; var AIVal: Integer): Integer;
begin
result := optdcdef.optGetIntNr(popt, ANr, AIVal);
end;

function  TGmsOptions.optGetInt2Nr(ANr: Integer; var AIVal: Integer): Integer;
begin
result := optdcdef.optGetInt2Nr(popt, ANr, AIVal);
end;

function  TGmsOptions.optSetIntNr(ANr: Integer; AIVal: Integer): Integer;
begin
result := optdcdef.optSetIntNr(popt, ANr, AIVal);
end;

function  TGmsOptions.optSetInt2Nr(ANr: Integer; AIVal: Integer): Integer;
begin
result := optdcdef.optSetInt2Nr(popt, ANr, AIVal);
end;

function  TGmsOptions.optGetStrNr(ANr: Integer; var ASVal: ShortString): Integer;
begin
result := optdcdef.optGetStrNr(popt, ANr, ASVal);
end;

function  TGmsOptions.optGetOptHelpNr(ANr: Integer; var AName: ShortString; var AHc: Integer; var AGroup: Integer): Integer;
begin
result := optdcdef.optGetOptHelpNr(popt, ANr, AName, AHc, AGroup);
end;

function  TGmsOptions.optGetEnumHelp(ANr: Integer; AOrd: Integer; var AHc: Integer; var AHelpStr: ShortString): Integer;
begin
result := optdcdef.optGetEnumHelp(popt, ANr, AOrd, AHc, AHelpStr);
end;

function  TGmsOptions.optGetEnumStrNr(ANr: Integer; var ASVal: ShortString; var AOrd: Integer): Integer;
begin
result := optdcdef.optGetEnumStrNr(popt, ANr, ASVal, AOrd);
end;

function  TGmsOptions.optGetEnumCount(ANr: Integer; var ACount: Integer): Integer;
begin
result := optdcdef.optGetEnumCount(popt, ANr, ACount);
end;

function  TGmsOptions.optGetEnumValue(ANr: Integer; AOrd: Integer; var AValInt: Integer; var AValStr: ShortString): Integer;
begin
result := optdcdef.optGetEnumValue(popt, ANr, AOrd, AValInt, AValStr);
end;

function  TGmsOptions.optGetStr2Nr(ANr: Integer; var ASVal: ShortString): Integer;
begin
result := optdcdef.optGetStr2Nr(popt, ANr, ASVal);
end;

function  TGmsOptions.optSetStrNr(ANr: Integer; const ASVal: ShortString): Integer;
begin
result := optdcdef.optSetStrNr(popt, ANr, ASVal);
end;

function  TGmsOptions.optSetStr2Nr(ANr: Integer; const ASVal: ShortString): Integer;
begin
result := optdcdef.optSetStr2Nr(popt, ANr, ASVal);
end;

function  TGmsOptions.optGetDblNr(ANr: Integer; var ADVal: Double): Integer;
begin
result := optdcdef.optGetDblNr(popt, ANr, ADVal);
end;

function  TGmsOptions.optGetDbl2Nr(ANr: Integer; var ADVal: Double): Integer;
begin
result := optdcdef.optGetDbl2Nr(popt, ANr, ADVal);
end;

function  TGmsOptions.optSetDblNr(ANr: Integer; ADVal: Double): Integer;
begin
result := optdcdef.optSetDblNr(popt, ANr, ADVal);
end;

function  TGmsOptions.optSetDbl2Nr(ANr: Integer; ADVal: Double): Integer;
begin
result := optdcdef.optSetDbl2Nr(popt, ANr, ADVal);
end;

function  TGmsOptions.optGetValStr(const AName: ShortString; var ASVal: ShortString): Integer;
begin
result := optdcdef.optGetValStr(popt, AName, ASVal);
end;

function  TGmsOptions.optGetVal2Str(const AName: ShortString; var ASVal: ShortString): Integer;
begin
result := optdcdef.optGetVal2Str(popt, AName, ASVal);
end;

function  TGmsOptions.optGetNameNr(ANr: Integer; var ASName: ShortString): Integer;
begin
result := optdcdef.optGetNameNr(popt, ANr, ASName);
end;

function  TGmsOptions.optGetDefinedNr(ANr: Integer; var AIVal: Integer): Integer;
begin
result := optdcdef.optGetDefinedNr(popt, ANr, AIVal);
end;

function  TGmsOptions.optGetHelpNr(ANr: Integer; var ASOpt: ShortString; var ASHelp: ShortString): Integer;
begin
result := optdcdef.optGetHelpNr(popt, ANr, ASOpt, ASHelp);
end;

function  TGmsOptions.optGetGroupNr(ANr: Integer; var AName: ShortString; var AGroup: Integer; var AHc: Integer; var AHelp: ShortString): Integer;
begin
result := optdcdef.optGetGroupNr(popt, ANr, AName, AGroup, AHc, AHelp);
end;

function  TGmsOptions.optGetGroupGrpNr(AGroup: Integer): Integer;
begin
result := optdcdef.optGetGroupGrpNr(popt, AGroup);
end;

function  TGmsOptions.optGetOptGroupNr(ANr: Integer): Integer;
begin
result := optdcdef.optGetOptGroupNr(popt, ANr);
end;

function  TGmsOptions.optGetDotOptNr(ANr: Integer; var AName: ShortString; var AObjNr: Integer; var ADim: Integer; var AValue: Double): Integer;
begin
result := optdcdef.optGetDotOptNr(popt, ANr, AName, AObjNr, ADim, AValue);
end;

function  TGmsOptions.optGetDotOptUel(ANr: Integer; ADim: Integer; var AUEL: ShortString): Integer;
begin
result := optdcdef.optGetDotOptUel(popt, ANr, ADim, AUEL);
end;

function  TGmsOptions.optGetIndicatorNr(ANr: Integer; var EquName: ShortString; var VarName: ShortString; var EquDim: Integer; var VarDim: Integer; var AValue: Integer): Integer;
begin
result := optdcdef.optGetIndicatorNr(popt, ANr, EquName, VarName, EquDim, VarDim, AValue);
end;

function  TGmsOptions.optGetEquIndicatorNr(ANr: Integer; ADim: Integer; var AIndex: ShortString): Integer;
begin
result := optdcdef.optGetEquIndicatorNr(popt, ANr, ADim, AIndex);
end;

function  TGmsOptions.optGetVarIndicatorNr(ANr: Integer; ADim: Integer; var AIndex: ShortString): Integer;
begin
result := optdcdef.optGetVarIndicatorNr(popt, ANr, ADim, AIndex);
end;

function  TGmsOptions.optIndicatorCount(var ANrErrors: Integer): Integer;
begin
result := optdcdef.optIndicatorCount(popt, ANrErrors);
end;

function  TGmsOptions.optDotOptCount(var ANrErrors: Integer): Integer;
begin
result := optdcdef.optDotOptCount(popt, ANrErrors);
end;

function  TGmsOptions.optSetRefNr(ANr: Integer; AValue: Integer): Integer;
begin
result := optdcdef.optSetRefNr(popt, ANr, AValue);
end;

function  TGmsOptions.optSetRefNrStr(const AOpt: ShortString; AValue: Integer): Integer;
begin
result := optdcdef.optSetRefNrStr(popt, AOpt, AValue);
end;

function  TGmsOptions.optGetConstName(cgroup: Integer; cindex: Integer; var cname: ShortString): Integer;
begin
result := optdcdef.optGetConstName(popt, cgroup, cindex, cname);
end;

function  TGmsOptions.optGetTypeName(TNr: Integer; var sTName: ShortString): Integer;
begin
result := optdcdef.optGetTypeName(popt, TNr, sTName);
end;

function  TGmsOptions.optLookUp(const AOpt: ShortString): Integer;
begin
result := optdcdef.optLookUp(popt, AOpt);
end;

procedure TGmsOptions.optReadFromPChar(p: PChar);
begin
optdcdef.optReadFromPChar(popt, p);
end;

end.
